#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define mp make_pair
#define mt make_tuple
#define sz size()
#define pb push_back
#define SPED ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0)
#define all(x) (x).begin(),(x).end()
#define allr(x) (x).rbegin(),(x).rend()
#define inv(n) power((n), mod - 2)
#define ff(i,a,b) for (long long (i) = (a); (i) < (b); (i)++)
#define fff(i,a,b) for (long long (i) = (a); (i) <= b; (i)++)
#define bff(i,a,b) for (long long (i) = (b)-1; (i) >= (a); (i)--)
#define bfff(i,a,b) for (long long (i) = (b); (i) >= (a); (i)--)
#define sum_overflow(a,b) __builtin_add_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)
#define mul_overflow(a,b) __builtin_mul_overflow_p ((a), (b), (__typeof__ ((a) * (b))) 0)
#define popcount(x) __builtin_popcountll(x)
#define PI 3.14159265358979323846

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef long long int ll;
typedef long double ld;
typedef unsigned long long int ull;
typedef pair<ll,ll> pll;
typedef vector<vector<ll>> graf;
typedef vector<vector<array<ll,2>>> graf_t;
typedef vector<vector<array<double,2>>> graf_d;
typedef array<ll,3> all;
typedef array<double,3> add;

const ll mod = 1e9+7;
const ll MOD = 998244353;
const ll MAXN = 2e5+10;
const ll INF = 1e18;
const ld EPS = 1e-9;

template <class T> using ordered_set = tree<T, null_type,less<T>, rb_tree_tag,tree_order_statistics_node_update>;
template <class T> using ordered_multiset = tree<T, null_type,less_equal<T>, rb_tree_tag,tree_order_statistics_node_update>;

struct FT
{
    ll n;
    vector<ll> ft = vector<ll>(MAXN);
    void add(ll pos, ll val)
    {
        for(;pos<=n;pos+=pos&-pos)
            ft[pos]=max(ft[pos],val);
    }

    ll mx(ll pos)
    {
        ll ans = 0;
        for(;pos>0;pos-=pos&-pos)
            ans=max(ans,ft[pos]);
        return ans;
    }

};


int main()
{
    SPED;
    ll n;
    cin >> n;
    FT f;
    f.n=n;
    vector<ll> a(n+1);
    vector<ll> lis(n+1);
    fff(i,1,n){
    cin >> a[i];
    lis[i]=1+f.mx(a[i]);
    f.add(a[i],lis[i]);
    }
    ll q;
    cin >> q;
    while(q--)
    {
        ll c,d;
        cin >> c >> d;
        --c;
        ll ans = lis[d]-lis[c];
        if(ans==d-c || ans==d-c-1)
            cout << "DA\n";
        else cout << "NE\n";
    }
    return 0;
}